<?php

/**
 * Allows common database call functionality
 */
class Shopgate_Helpers_Database
{
    /**
     * Checks if the column exists within the table.
     *
     * @param string $table
     * @param string $column
     *
     * @return bool
     */
    public function db_column_exists($table, $column)
    {
        $query  = "SHOW COLUMNS FROM {$table} LIKE '{$column}';";
        $result = xtc_db_query($query);

        return (bool) xtc_db_num_rows($result);
    }

    /**
     * Retrieves the correct column name for option weight prefix
     *
     * @return string
     */
    public function getWeightPrefixColumnName()
    {
        $columnName = '';
        if ($this->db_column_exists(TABLE_PRODUCTS_ATTRIBUTES, 'products_attributes_weight_prefix')) {
            $columnName = 'products_attributes_weight_prefix';
        } elseif ($this->db_column_exists(TABLE_PRODUCTS_ATTRIBUTES, 'weight_prefix')) {
            $columnName = 'weight_prefix';
        }

        return $columnName;
    }

    /**
     *
     * Retrieves the correct column name for option weight
     *
     * @return string
     */
    public function getWeightColumnName()
    {
        $columnName = '';
        if ($this->db_column_exists(TABLE_PRODUCTS_ATTRIBUTES, 'products_attributes_weight')) {
            $columnName = 'products_attributes_weight';
        } elseif ($this->db_column_exists(TABLE_PRODUCTS_ATTRIBUTES, 'options_values_weight')) {
            $columnName = 'options_values_weight';
        }

        return $columnName;
    }

    /**
     * @param string $moduleName
     *
     * @return bool
     */
    public function isPaymentModuleActive($moduleName)
    {
        $moduleName = 'MODULE_PAYMENT_' . strtoupper($moduleName) . '_STATUS';
        $qry        = "SELECT configuration_value FROM configuration WHERE configuration_key = '{$moduleName}'";
        $result     = xtc_db_query($qry);
        $value      = xtc_db_fetch_array($result);

        return isset($value['configuration_value']) && $value['configuration_value'] !== 'False';
    }
}
