<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain
 * unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */
class Shopgate_Helpers_Payment_Modules_Debit_Banktransfer extends Shopgate_Helpers_Payment_Modules_Generic
{
    const MODULE_NAME = 'banktransfer';

    public function getHistoryComments()
    {
        $comment = "Sie müssen nun den Geldbetrag per Lastschrift von dem Bankkonto des Kunden abbuchen: \n\n";
        return $comment . "\n" . parent::getHistoryComments();
    }

    /**
     * @inheritdoc
     */
    public function saveAdditionalInfo($orderId, array $data = null)
    {
        $paymentInfo = $this->getOrder()->getPaymentInfos();
        $data        = array(
            'orders_id'             => $orderId,
            'banktransfer_owner'    => $paymentInfo['bank_account_holder'],
            'banktransfer_number'   => $paymentInfo['bank_account_number'],
            'banktransfer_bankname' => $paymentInfo['bank_name'],
            'banktransfer_blz'      => $paymentInfo['bank_code'],
            'banktransfer_status'   => '0',
            'banktransfer_prz'      => $orderId,
            'banktransfer_fax'      => null

        );

        xtc_db_perform(self::MODULE_NAME, $data);
    }
}
