<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain
 * unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */
class Shopgate_Models_Order
{
    /** @var Shopgate_Helpers_Database $dbHelper */
    private $dbHelper;

    /**
     * @param Shopgate_Helpers_Database $dbHelper
     */
    public function __construct(Shopgate_Helpers_Database $dbHelper)
    {
        $this->dbHelper = $dbHelper;
    }

    /**
     * Check if a Shopgate order already exist in the database
     *
     * @param $orderNumber
     *
     * @throws ShopgateLibraryException
     */
    public function orderExists($orderNumber)
    {
        // check that the order is not imported already
        $qry     = "SELECT
                    o.*,
                    so.shopgate_order_number
                    FROM " . TABLE_ORDERS . " o
                    INNER JOIN " . TABLE_SHOPGATE_ORDERS . " so ON (so.orders_id = o.orders_id)
                    WHERE so.shopgate_order_number = '{$orderNumber}'";

        $result  = xtc_db_query($qry);
        $dbOrder = xtc_db_fetch_array($result);

        if (!empty($dbOrder)) {
            throw new ShopgateLibraryException(
                ShopgateLibraryException::PLUGIN_DUPLICATE_ORDER,
                'external_order_number: ' . $dbOrder["orders_id"],
                true
            );
        }
    }

    /**
    * @param ShopgateOrder|ShopgateAddress $object
    * @param string                        $table
    *
    * @return array
    */
    public function addCustomFields($object, $table = TABLE_ORDERS)
    {
        $orderData = array();
        foreach ($object->getCustomFields() as $field) {
            if ($this->dbHelper->db_column_exists($table, $field->getInternalFieldName())) {
                $orderData[$field->getInternalFieldName()] = $field->getValue();
            }
        }

        return $orderData;
    }
}
