<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain
 * unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */

namespace Shopgate\Xtcommerce3\Tracking\Repository;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentType;
use Shopgate\Xtcommerce3\Tracking\Entity\Cart;

interface EventData
{
    /**
     * @return string
     */
    public function getScriptName();

    /**
     * @return string
     */
    public function getPageName();

    /**
     * @return string
     */
    public function getCurrencyCode();

    /**
     * @return mixed
     */
    public function getNativeCart();

    /**
     * @return Cart
     */
    public function getShadowCart();

    /**
     * @param Cart $cart
     */
    public function persistShadowCart(Cart $cart);

    /**
     * @return ContentType
     */
    public function getCurrentProductContentType();
    
    /**
     * @return string
     */
    public function getCurrentProductSku();

    /**
     * @return string
     */
    public function getCurrentProductId();

    /**
     * @return string
     */
    public function getCurrentProductName();

    /**
     * @return int
     */
    public function getCurrentProductPrice();
}