<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain
 * unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */

namespace Shopgate\Xtcommerce3\Tracking\Repository\Globals\Datasource;


use Shopgate\Xtcommerce3\Tracking\Entity\Cart;

class ShadowCart
{
    const DEFAULT_SHADOW_CART_FIELD_NAME = 'shadow_cart';

    /** @var array */
    private $session;

    /** @var string */
    private $shadowCartFieldName;

    /**
     * @param array  $session
     * @param string $shadowCartFieldName
     */
    public function __construct(array &$session = array(), $shadowCartFieldName = self::DEFAULT_SHADOW_CART_FIELD_NAME)
    {
        $this->session             = &$session;
        $this->shadowCartFieldName = $shadowCartFieldName;
    }

    /**
     * @return Cart|null
     */
    public function getCart()
    {
        $cart = @unserialize($_SESSION['shopgate'][$this->shadowCartFieldName]);

        if (false === $cart) {
            return null;
        }

        return $cart;
    }

    /**
     * @return Cart
     */
    public function createCart()
    {
        $this->persistCart(new Cart);
        
        return $this->getCart();
    }

    /**
     * @param Cart $cart
     */
    public function persistCart(Cart $cart)
    {
        $_SESSION['shopgate'][$this->shadowCartFieldName] = serialize($cart);
    }
}