<?php

namespace Shopgate\FacebookPixelLibrary\Base\ValueObject;

abstract class Enum
{
    /** @var string */
    private $value;

    /**
     * @param string $value
     */
    public function __construct($value)
    {
        if (!is_string($value) || !in_array($value, $this->getEnumValues(), true)) {
            throw new \InvalidArgumentException(
                'constructor argument for ' . get_class($this)
                . ' is not a valid value but ' . gettype($value) . ': ' . print_r($value, true)
            );
        }

        $this->value = $value;
    }

    /**
     * @return string[]
     */
    public abstract function getEnumValues();

    /**
     * @return string
     */
    public function getString()
    {
        return $this->value;
    }

    /**
     * @return string
     */
    public function getStringRawUrlEncoded()
    {
        return rawurlencode($this->value);
    }
}