<?php

namespace Shopgate\FacebookPixelLibrary\Base\ValueObject;

class PositiveIntegerValueObject
{
    /** @var int */
    private $value;

    /**
     * @param int $value
     */
    public function __construct($value)
    {
        if (!is_int($value)) {
            throw new \InvalidArgumentException('constructor argument for ' . get_class($this)
                . ' is not an int but a ' . gettype($value) . ': ' . print_r($value, true));
        }
        if ($value < 0) {
            throw new \InvalidArgumentException('constructor argument for ' . get_class($this)
                . ' is not an int >= 0 a ' . gettype($value) . ': ' . print_r($value, true));
        }

        $this->value = $value;
    }

    /**
     * @return int
     */
    public function getInt()
    {
        return $this->value;
    }
}