<?php

namespace Shopgate\FacebookPixelLibrary\Base\ValueObject;


class StringValueObject
{
    /** @var string */
    private $value;

    /**
     * @param string $value
     */
    public function __construct($value)
    {
        if (!is_string($value)) {
            throw new \InvalidArgumentException('constructor argument for ' . get_class($this)
                . ' is not a string but a ' . gettype($value) . ': ' . print_r($value, true));
        }

        $this->value = $value;
    }

    /**
     * @return string
     */
    public function getString()
    {
        return $this->value;
    }

    /**
     * @return string
     */
    public function getStringRawUrlEncoded()
    {
        return rawurlencode($this->value);
    }
}