<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentCategory;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentId;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class AddPaymentInfo extends FacebookTrackingEvent
{
    /** @var ContentCategory */
    public $content_category;

    /** @var ContentId[] */
    public $content_ids;

    /**
     * @param Value|null           $value
     * @param Currency|null        $currency
     * @param ContentCategory|null $contentCategory
     * @param ContentId[]|null     $contentIds
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentCategory $contentCategory = null,
        array $contentIds = null
    ) {
        parent::__construct($value, $currency);
        $this->content_category = $contentCategory;
        $this->content_ids      = $contentIds;
    }
}