<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentName;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Status;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class CompleteRegistration extends FacebookTrackingEvent
{
    /** @var ContentName */
    public $content_name;

    /** @var Status */
    public $status;

    /**
     * @param Value|null       $value
     * @param Currency|null    $currency
     * @param ContentName|null $contentName
     * @param Status|null      $status
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentName $contentName = null,
        Status $status = null

    ) {
        parent::__construct($value, $currency);
        $this->content_name = $contentName;
        $this->status       = $status;
    }
}