<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentCategory;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentId;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentName;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\NumItems;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class InitiateCheckout extends FacebookTrackingEvent
{
    /** @var ContentName */
    public $content_name;

    /** @var ContentCategory */
    public $content_category;

    /** @var ContentId[] */
    public $content_ids;

    /** @var NumItems */
    public $num_items;

    /**
     * @param Value|null           $value
     * @param Currency|null        $currency
     * @param ContentName|null     $contentName
     * @param ContentCategory|null $contentCategory
     * @param ContentId[]|null     $contentIds
     * @param NumItems|null        $numItems
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentName $contentName = null,
        ContentCategory $contentCategory = null,
        array $contentIds = null,
        NumItems $numItems = null
    ) {
        parent::__construct($value, $currency);
        $this->content_name     = $contentName;
        $this->content_category = $contentCategory;
        $this->content_ids      = $contentIds;
        $this->num_items        = $numItems;
    }
}