<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentCategory;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentName;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class Lead extends FacebookTrackingEvent
{
    /** @var ContentName */
    public $content_name;

    /** @var ContentCategory */
    public $content_category;

    /**
     * @param Value|null           $value
     * @param Currency|null        $currency
     * @param ContentName|null     $contentName
     * @param ContentCategory|null $contentCategory
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentName $contentName = null,
        ContentCategory $contentCategory = null

    ) {
        parent::__construct($value, $currency);
        $this->content_name     = $contentName;
        $this->content_category = $contentCategory;
    }
}