<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentId;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentName;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentType;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\NumItems;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class Purchase extends FacebookTrackingEvent
{
    /** @var ContentName */
    public $content_name;

    /** @var ContentType */
    public $content_type;

    /** @var ContentId[] */
    public $content_ids;

    /** @var NumItems */
    public $num_items;

    /**
     * @param Value|null       $value
     * @param Currency|null    $currency
     * @param ContentName|null $contentName
     * @param ContentType|null $contentType
     * @param ContentId[]|null $contentIds
     * @param NumItems|null    $numItems
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentName $contentName = null,
        ContentType $contentType = null,
        array $contentIds = null,
        NumItems $numItems = null
    ) {
        parent::__construct($value, $currency);
        $this->content_name = $contentName;
        $this->content_type = $contentType;
        $this->content_ids  = $contentIds;
        $this->num_items    = $numItems;
    }
}