<?php

namespace Shopgate\FacebookPixelLibrary\Event\Event;

use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentCategory;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentId;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\SearchString;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class Search extends FacebookTrackingEvent
{
    /** @var ContentCategory */
    public $content_category;

    /** @var ContentId[] */
    public $content_ids;

    /** @var SearchString */
    public $search_string;

    /**
     * @param Value|null           $value
     * @param Currency|null        $currency
     * @param ContentCategory|null $contentCategory
     * @param ContentId[]|null     $contentIds
     * @param SearchString|null    $searchString
     */
    public function __construct(
        Value $value = null,
        Currency $currency = null,
        ContentCategory $contentCategory = null,
        array $contentIds = null,
        SearchString $searchString = null
    ) {
        parent::__construct($value, $currency);
        $this->content_category = $contentCategory;
        $this->content_ids      = $contentIds;
        $this->search_string    = $searchString;
    }
}