<?php

namespace Shopgate\FacebookPixelLibrary\Event\Factory;

use Shopgate\FacebookPixelLibrary\Event\Service\EventRenderer;

interface EventRendererFactory
{
    /**
     * Returns a renderer that will create standard Facebook tracking event pixels.
     *
     * @return EventRenderer
     */
    public function getRenderer();

    /**
     * Returns a renderer that will create custom tracking event pixels.
     *
     * @return EventRenderer
     */
    public function getRendererTrackCustom();
}