<?php

namespace Shopgate\FacebookPixelLibrary\Event\Factory;

use Shopgate\FacebookPixelLibrary\Base\Repository\Settings;
use Shopgate\FacebookPixelLibrary\Event\Service\ImageTag;
use Shopgate\FacebookPixelLibrary\Event\Service\JavaScriptTag;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\TrackingType;

class JavaScriptTagRendererFactory implements EventRendererFactory
{
    /** @var Settings */
    private $settings;

    /**
     * @param Settings $settings
     */
    public function __construct(Settings $settings)
    {
        $this->settings = $settings;
    }

    public function getRenderer()
    {
        return $this->getRendererForType(new TrackingType(TrackingType::TRACK));
    }

    public function getRendererTrackCustom()
    {
        return $this->getRendererForType(new TrackingType(TrackingType::TRACK_CUSTOM));
    }

    /**
     * @param TrackingType $trackingType
     *
     * @return JavaScriptTag
     */
    private function getRendererForType(TrackingType $trackingType)
    {
        return new JavaScriptTag(
            new ImageTag($this->settings),
            $this->settings,
            $trackingType
        );
    }

}