<?php

namespace Shopgate\FacebookPixelLibrary\Event\Service;


use Shopgate\FacebookPixelLibrary\Event\Event\FacebookTrackingEvent;

interface EventRenderer
{
    /**
     * Renders an event into a string that can be placed whereever events need to be tracked.
     *
     * Common use cases:
     * - an HTML image tag that is inserted into a website
     * - a JavaScript snippet that is inserted into a website's head tags
     *
     * @param FacebookTrackingEvent[] $events
     *
     * @return string
     */
    public function render(array $events);
}