<?php

namespace Shopgate\FacebookPixelLibrary\Event\ValueObject;

use Shopgate\FacebookPixelLibrary\Base\ValueObject\StringValueObject;

class Currency extends StringValueObject
{
    /**
     * @param string $value currency code with 3 upper case characters
     */
    public function __construct($value)
    {
        parent::__construct($value);

        if (($value !== strtoupper($value)) || strlen($value) != 3) {
            throw new \InvalidArgumentException('constructor argument for ' . get_class($this)
                . ' is not a string with three upper case chars, but ' . gettype($value) . ': '
                . print_r($value, true)
            );
        }
    }
}