<?php

namespace Shopgate\FacebookPixelLibrary\Setting\Entity;

use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Description;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Label;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Link;

class Details
{
    /** @var Label */
    private $label;

    /** @var Link */
    private $url;

    /** @var Description */
    private $description;

    /**
     * @param Label       $label
     * @param Link        $url
     * @param Description $description
     */
    public function __construct(Label $label, Link $url, Description $description)
    {
        $this->label       = $label;
        $this->url         = $url;
        $this->description = $description;
    }

    /**
     * @return Label
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * @return Link
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * @return Description
     */
    public function getDescription()
    {
        return $this->description;
    }
}