<?php

namespace Shopgate\FacebookPixelLibrary\Setting\Entity;

use Shopgate\FacebookPixelLibrary\Setting\ValueObject\EventSettingFieldName;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\EventSettingLabel;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Label;

class EventSetting
{
    /** @var EventSettingFieldName */
    private $fieldName;

    /** @var Label */
    private $label;

    /** @var Label */
    private $activeLabel;

    /** @var Label */
    private $inactiveLabel;

    /**
     * @param EventSettingFieldName $fieldName
     * @param Label                 $label
     * @param EventSettingLabel     $activeLabel
     * @param EventSettingLabel     $inactiveLabel
     */
    public function __construct(
        EventSettingFieldName $fieldName,
        Label $label,
        EventSettingLabel $activeLabel,
        EventSettingLabel $inactiveLabel
    ) {
        $this->fieldName     = $fieldName;
        $this->label         = $label;
        $this->activeLabel   = $activeLabel;
        $this->inactiveLabel = $inactiveLabel;
    }

    /**
     * @return EventSettingFieldName
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }

    /**
     * @return Label
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * @return Label
     */
    public function getActiveLabel()
    {
        return $this->activeLabel;
    }

    /**
     * @return Label
     */
    public function getInactiveLabel()
    {
        return $this->inactiveLabel;
    }
}