<?php

namespace Shopgate\FacebookPixelLibrary\Setting\Entity;

use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Title;

class SettingsSection
{
    /** @var Title */
    private $title;

    /** @var Details */
    private $details;

    /** @var EventSetting[] */
    private $eventSettings;

    /**
     * @param Title          $title
     * @param Details        $details
     * @param EventSetting[] $eventSettings
     */
    public function __construct(
        Title $title,
        Details $details,
        array $eventSettings
    ) {
        $this->title         = $title;
        $this->details       = $details;
        $this->eventSettings = $eventSettings;
    }

    /**
     * @return Title
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * @return Details
     */
    public function getDetails()
    {
        return $this->details;
    }

    /**
     * @return EventSetting[]
     */
    public function getEventSettings()
    {
        return $this->eventSettings;
    }
}