<?php

namespace Shopgate\FacebookPixelLibrary\Setting\Repository\Provider;

use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Description;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\EventSettingLabel;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Label;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Link;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Title;

interface Translation
{
    /**
     * @return Title
     */
    public function getSettingsSectionTitle();

    /**
     * @return Label
     */
    public function getDetailsLabel();

    /**
     * @return Link
     */
    public function getDetailsLink();

    /**
     * @return Description
     */
    public function getDetailsDescription();

    /**
     * @return Label
     */
    public function getLabelViewContentSetting();

    /**
     * @return Label
     */
    public function getLabelAddToCartSetting();

    /**
     * @return Label
     */
    public function getLabelInitiateCheckoutSetting();

    /**
     * @return Label
     */
    public function getLabelPurchaseSetting();

    /**
     * @return Label
     */
    public function getLabelSearchSetting();

    /**
     * @return Label
     */
    public function getLabelAddToWishlistSetting();

    /**
     * @return Label
     */
    public function getLabelAddPaymentInfoSetting();

    /**
     * @return Label
     */
    public function getLabelLeadSetting();

    /**
     * @return Label
     */
    public function getLabelCompleteRegistrationSetting();

    /**
     * @return EventSettingLabel
     */
    public function getEventSettingActiveLabel();

    /**
     * @return EventSettingLabel
     */
    public function getEventSettingInactiveLabel();
}