<?php

namespace Shopgate\FacebookPixelLibrary\Setting\Repository\StaticStrings;

use Shopgate\FacebookPixelLibrary\Setting\Repository\Provider\Translation;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Description;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\EventSettingLabel;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Label;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Link;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\LinkTitle;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\LinkUrl;
use Shopgate\FacebookPixelLibrary\Setting\ValueObject\Title;

class English implements Translation
{
    public function getSettingsSectionTitle()
    {
        return new Title('Facebook Pixel Tracking');
    }

    public function getDetailsLabel()
    {
        return new Label('Details');
    }

    public function getDetailsLink()
    {
        return new Link(
            new LinkUrl('https://www.shopgate.com/en/services/'),
            new LinkTitle('More about our App Marketing Services')
        );
    }

    public function getDetailsDescription()
    {
        return new Description(
            'We offer Facebook Pixel as a part of our App Marketing Services. Pixel-Tracking allows you to drive ' .
            'downloads and improve user retention. With Pixel-Tracking, you can target your Facebook ads and ' .
            'increase your success.'
        );
    }

    public function getLabelViewContentSetting()
    {
        return new Label('View Content Event');
    }

    public function getLabelAddToCartSetting()
    {
        return new Label('Add To Cart Event');
    }

    public function getLabelInitiateCheckoutSetting()
    {
        return new Label('Initiate Checkout Event');
    }

    public function getLabelPurchaseSetting()
    {
        return new Label('Purchase Event');
    }

    public function getLabelSearchSetting()
    {
        return new Label('Search Event');
    }

    public function getLabelAddToWishlistSetting()
    {
        return new Label('Add To Wishlist Event');
    }

    public function getLabelAddPaymentInfoSetting()
    {
        return new Label('Add Payment Info Event');
    }

    public function getLabelLeadSetting()
    {
        return new Label('Lead Event');
    }

    public function getLabelCompleteRegistrationSetting()
    {
        return new Label('Complete Registration Event');
    }

    public function getEventSettingActiveLabel()
    {
        return new EventSettingLabel('Activate');
    }

    public function getEventSettingInactiveLabel()
    {
        return new EventSettingLabel('Deactivate');
    }
}