<?php

namespace Shopgate\FacebookPixelLibrary\Setting\ValueObject;

use Shopgate\FacebookPixelLibrary\Base\ValueObject\Enum;

class EventName extends Enum
{
    const VIEW_CONTENT          = 'ViewContent';
    const ADD_TO_CART           = 'AddToCart';
    const INITIATE_CHECKOUT     = 'InitiateCheckout';
    const PURCHASE              = 'Purchase';
    const SEARCH                = 'Search';
    const ADD_TO_WISHLIST       = 'AddToWishlist';
    const ADD_PAYMENT_INFO      = 'AddPaymentInfo';
    const LEAD                  = 'Lead';
    const COMPLETE_REGISTRATION = 'CompleteRegistration';

    private $settingsFieldNamesByEventNames = array(
        self::VIEW_CONTENT          => 'view_content',
        self::ADD_TO_CART           => 'add_to_cart',
        self::INITIATE_CHECKOUT     => 'initiate_checkout',
        self::PURCHASE              => 'purchase',
        self::SEARCH                => 'search',
        self::ADD_TO_WISHLIST       => 'add_to_wishlist',
        self::ADD_PAYMENT_INFO      => 'add_payment_info',
        self::LEAD                  => 'lead',
        self::COMPLETE_REGISTRATION => 'complete_registration',
    );

    public function getEnumValues()
    {
        return array(
            self::VIEW_CONTENT,
            self::ADD_TO_CART,
            self::INITIATE_CHECKOUT,
            self::PURCHASE,
            self::SEARCH,
            self::ADD_TO_WISHLIST,
            self::ADD_PAYMENT_INFO,
            self::LEAD,
            self::COMPLETE_REGISTRATION,
        );
    }

    /**
     * @return string
     */
    public function getSettingsFieldName()
    {
        return $this->settingsFieldNamesByEventNames[$this->getString()];
    }
}