<?php

namespace Shopgate\FacebookPixelLibrary\Tests\Fixtures\Unit\Event\Service;

use Shopgate\FacebookPixelLibrary\Event\Event\AddPaymentInfo;
use Shopgate\FacebookPixelLibrary\Event\Event\AddToCart;
use Shopgate\FacebookPixelLibrary\Event\Event\AddToWishlist;
use Shopgate\FacebookPixelLibrary\Event\Event\CompleteRegistration;
use Shopgate\FacebookPixelLibrary\Event\Event\InitiateCheckout;
use Shopgate\FacebookPixelLibrary\Event\Event\Lead;
use Shopgate\FacebookPixelLibrary\Event\Event\Purchase;
use Shopgate\FacebookPixelLibrary\Event\Event\Search;
use Shopgate\FacebookPixelLibrary\Event\Event\ViewContent;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentCategory;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentId;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentName;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\ContentType;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Currency;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\NumItems;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\SearchString;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Status;
use Shopgate\FacebookPixelLibrary\Event\ValueObject\Value;

class FixtureProvider
{
    /**
     * @return array
     */
    public function provideJavaScriptRenderCases()
    {
        return array(
            'AddPaymentInfo'          => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'AddPaymentInfo\', {value: 1.5, currency: \'USD\', content_category: \'Test Category\', content_ids: [\'1234\']});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new AddPaymentInfo(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'ViewContent'             => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'ViewContent\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_type: \'product\', content_ids: [\'1234\']});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new ViewContent(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToCart'               => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'AddToCart\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_type: \'product\', content_ids: [\'1234\']});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new AddToCart(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToWishlist'           => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'AddToWishlist\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_category: \'Test Category\', content_ids: [\'1234\']});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new AddToWishlist(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'CompleteRegistration'    => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'CompleteRegistration\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', status: \'complete\'});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new CompleteRegistration(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new Status('complete')
                    ),
                ),
            ),
            'InitiateCheckout'        => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'InitiateCheckout\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_category: \'Test Category\', content_ids: [\'1234\'], num_items: 12});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new InitiateCheckout(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Lead'                    => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'Lead\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_category: \'Test Category\'});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new Lead(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category')
                    ),
                ),
            ),
            'Purchase'                => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'Purchase\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_type: \'product\', content_ids: [\'1234\'], num_items: 12});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new Purchase(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Search'                  => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'Search\', {value: 1.5, currency: \'USD\', content_category: \'Test Category\', content_ids: [\'1234\'], search_string: \'search string\'});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new Search(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new SearchString('search string')
                    ),
                ),
            ),
            'AddToCart & ViewContent' => array(
                '
<!-- Facebook Pixel Code -->
<script>
!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
n.push=n;n.loaded=!0;n.version=\'2.0\';n.queue=[];t=b.createElement(e);t.async=!0;
t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
document,\'script\',\'https://connect.facebook.net/en_US/fbevents.js\');

fbq(\'init\', \'1234567\');
fbq(\'track\', \'AddToCart\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_type: \'product\', content_ids: [\'1234\']});
fbq(\'track\', \'ViewContent\', {value: 1.5, currency: \'USD\', content_name: \'Shoes\', content_type: \'product\', content_ids: [\'1234\']});
</script>
<noscript><img width="0" height="0" src="test" /></noscript>
<!-- End Facebook Pixel Code -->',
                array(
                    new AddToCart(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                    new ViewContent(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
        );
    }

    /**
     * @return array
     */
    public function provideImageRenderCases()
    {
        return array(
            'ViewContent'             => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=ViewContent&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_type]=product&cd[content_ids]=1234&noscript=1"/>',
                array(
                    new ViewContent(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddPaymentInfo'          => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=AddPaymentInfo&cd[value]=1.5&cd[currency]=USD&cd[content_category]=Test%20Category&cd[content_ids]=1234&noscript=1"/>',
                array(
                    new AddPaymentInfo(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToCart'               => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=AddToCart&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_type]=product&cd[content_ids]=1234&noscript=1"/>',
                array(
                    new AddToCart(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToWishlist'           => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=AddToWishlist&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_category]=Test%20Category&cd[content_ids]=1234&noscript=1"/>',
                array(
                    new AddToWishlist(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'CompleteRegistration'    => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=CompleteRegistration&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[status]=complete&noscript=1"/>',
                array(
                    new CompleteRegistration(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new Status('complete')
                    ),
                ),
            ),
            'InitiateCheckout'        => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=InitiateCheckout&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_category]=Test%20Category&cd[content_ids]=1234&cd[num_items]=12&noscript=1"/>',
                array(
                    new InitiateCheckout(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Lead'                    => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=Lead&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_category]=Test%20Category&noscript=1"/>',
                array(
                    new Lead(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category')
                    ),
                ),
            ),
            'Purchase'                => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=Purchase&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_type]=product&cd[content_ids]=1234&cd[num_items]=12&noscript=1"/>',
                array(
                    new Purchase(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Search'                  => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=Search&cd[value]=1.5&cd[currency]=USD&cd[content_category]=Test%20Category&cd[content_ids]=1234&cd[search_string]=search%20string&noscript=1"/>',
                array(
                    new Search(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new SearchString('search string')
                    ),
                ),
            ),
            'AddToCart & ViewContent' => array(
                '<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=AddToCart&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_type]=product&cd[content_ids]=1234&noscript=1"/>
<img height="1" width="1" border="0" alt="" style="display:none" src="https://www.facebook.com/tr?id=1234567&ev=ViewContent&cd[value]=1.5&cd[currency]=USD&cd[content_name]=Shoes&cd[content_type]=product&cd[content_ids]=1234&noscript=1"/>',
                array(
                    new AddToCart(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                    new ViewContent(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
        );
    }

    /**
     * @return array
     */
    public function provideAllEvents()
    {
        return array(
            'AddPaymentInfo'       => array(
                array(
                    new AddPaymentInfo(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToCart'            => array(
                array(
                    new AddToCart(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'AddToWishlist'        => array(
                array(
                    new AddToWishlist(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
            'CompleteRegistration' => array(
                array(
                    new CompleteRegistration(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new Status('complete')
                    ),
                ),
            ),
            'InitiateCheckout'     => array(
                array(
                    new InitiateCheckout(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Lead'                 => array(
                array(
                    new Lead(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentCategory('Test Category')
                    ),
                ),
            ),
            'Purchase'             => array(
                array(
                    new Purchase(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        ),
                        new NumItems(12)
                    ),
                ),
            ),
            'Search'               => array(
                array(
                    new Search(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentCategory('Test Category'),
                        array(
                            new ContentId('1234'),
                        ),
                        new SearchString('search string')
                    ),
                ),
            ),
            'ViewContent'          => array(
                array(
                    new ViewContent(
                        new Value('1.5'),
                        new Currency('USD'),
                        new ContentName('Shoes'),
                        new ContentType('product'),
                        array(
                            new ContentId('1234'),
                        )
                    ),
                ),
            ),
        );
    }
}