<?php

namespace Shopgate\FacebookPixelLibrary\Tests\Unit\Base\ValueObject;

use Shopgate\FacebookPixelLibrary\Base\ValueObject\StringValueObject;

class StringValueObjectTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @param mixed $inputParameter
     *
     * @dataProvider provideInvalidParameter
     */
    public function testInvalidParameter($inputParameter)
    {
        $this->setExpectedException('\InvalidArgumentException');
        new StringValueObject($inputParameter);
    }

    /**
     * @return array
     */
    public function provideInvalidParameter()
    {
        return array(
            'null'         => array(
                null,
            ),
            'float'        => array(
                1.0,
            ),
            'stdClass'     => array(
                new \stdClass(),
            ),
            'array'        => array(
                array(),
            ),
            'negative int' => array(
                -3,
            ),
            'positive int' => array(
                4,
            ),
            'zero'         => array(
                0,
            ),
        );
    }

    /**
     * @param mixed $inputParameter
     *
     * @dataProvider provideValidParameter
     */
    public function testValidParameter($inputParameter)
    {
        new StringValueObject($inputParameter);
    }

    /**
     * @return array
     */
    public function provideValidParameter()
    {
        return array(
            'string'       => array(
                'test',
            ),
            'empty string' => array(
                '',
            ),
        );
    }
}